/*
 * MessageFacade.java
 *
 * Created on 21 maj 2007, 15:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package eu.bojar.hibernatetest.service;

import java.util.Collection;
import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import eu.bojar.hibernatetest.model.Message;

/**
 *
 * @author Jarek
 */
@Stateless
public class MessageFacade implements MessageFacadeLocal {

    @PersistenceContext
    private EntityManager em;
    
    /** Creates a new instance of MessageFacade */
    public MessageFacade() {
    }
    
    @Override
    public void initDatabase() {
    	if (null == em.find(Message.class, 1L)) {
    		Message msg1 = new Message(1L, "Message 1 subject");
    		em.persist(msg1);
    		Message msg2 = new Message(2L, "Message 2 subject");
    		em.persist(msg2);
    		
    		msg2.setPrevious(msg1);
    		msg1.getNext().add(msg2);
    	}
    }

    public void create(Message message) {
        em.persist(message);
    }

    public void create(Collection<Message> messages) {
        for (Message message : messages) {
            create(message);
        }
    }
    
    public void edit(Message message) {
        em.merge(message);
    }

    public void destroy(Message message) {
        em.remove(em.merge(message));
    }

    public Message find(long pk) {
      return em.find(Message.class, pk);
    }
    
    public Message getReference(long pk) {
        return em.getReference(Message.class, pk);
    }
    
    @SuppressWarnings("unchecked")
	public List<Message> findAll() {
        return em.createQuery("select object(o) from Message as o").getResultList();
    }

    public void destroy(Collection<Message> messages) {
        for (Message message : messages) {
            destroy(message);
        }
    }

    public void edit(Collection<Message> messages) {
        for (Message message : messages) {
            edit(message);
        }
    }

}
